
extends "res://scripts/BaseLevel.gd"



# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var enemy_scene = load('res://scenes/Enemy.tscn')
var rail_enemy = load('res://scenes/EnemyRailing.tscn')
var random = RandomNumberGenerator.new()

var spawnpoints = []

var enemy_type_spawnpoints = {
	'Spawnpoints': enemy_scene,
	'RailSpawnpoints': rail_enemy
}


signal rollforhit



# Called when the node enters the scene tree for the first time.
func _ready():
	$songloop.play()
	start_game()



func _get_spawnpoints():
	spawnpoints = []
	for s in enemy_type_spawnpoints.keys(): 
		var points = get_node(s).get_children()
		var entry = {
			'enemy_type': s, 
			'points': []
		}
		for p in points:
			entry['points'].push_back(p.position)
		spawnpoints.push_back(entry)



func _on_SpawnTimer_timeout():
	if spawnpoints:
		var enemyIndex = randi() % spawnpoints.size()
		var spawnGroup = spawnpoints[enemyIndex]
		var spawnIndex = randi() % spawnGroup['points'].size()
		var spawnPoint = spawnGroup['points'][spawnIndex]
		var enemy = enemy_type_spawnpoints[spawnGroup['enemy_type']].instance()
		spawnGroup['points'].remove(spawnIndex)
		if spawnGroup['points'].size() < 1:
			spawnpoints.remove(enemyIndex)
		initialize_enemy(enemy, $Player)
		random.randomize()
		enemy.position = spawnPoint
		# hack to keep the living front enemies from being behind the dead balcony enemies
		# not ideal
		if spawnGroup['enemy_type'] == 'Spawnpoints':
			enemy.z_index = 4
		add_child(enemy)
		living_enemies +=1 
	elif living_enemies < 1:
		# placeholder, make an end screen yo
		$NextLevelNode.show()
	else:
		pass
	


func next_level():
	pass
	get_tree().change_scene("res:///scenes/LevelScripted1.tscn")
	
func remove_enemy():
	living_enemies -= 1


func start_game():
		
	$Player.refresh()
	_get_spawnpoints()
	living_enemies = 0
	$"SpawnTimer".start()

func game_over():
	get_tree().call_group("enemies", "queue_free")
#	enemies = []
	$"SpawnTimer".stop()






func _on_NextLevel_pressed():
	next_level()
	pass # Replace with function body.
