
extends "res://scripts/BaseLevel.gd"



# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var free_standing = load('res://scenes/EnemyFreeStanding.tscn')
var rail_enemy = load('res://scenes/EnemyRailing.tscn')
var falling_enemy = load('res://scenes/EnemyFalling.tscn')
var enemies_defeated = 0
var spawnpoints = []
var enemies = [
	{ 
		"enemy": free_standing, 
		"animation": "die1",
	},
	{ 
		"enemy": free_standing, 
		"animation": "die1",
	},
	{ 
		"enemy": free_standing, 
		"animation": "die2",
	},
	{ 
		"enemy": rail_enemy
	},
	{ 
		"enemy": free_standing, 
		"animation": "die2",
	},
	{
		"enemy": falling_enemy
	}
]

signal rollforhit


# Called when the node enters the scene tree for the first time.
func _ready():
	$songloop.play()
	spawnpoints = get_node('Spawnpoints').get_children()
	living_enemies = 0
	start_game()


func _on_SpawnTimer_timeout():
	if living_enemies == 0 and enemies_defeated < enemies.size():
		var enemy_attributes = enemies[enemies_defeated]
		var enemy = enemy_attributes["enemy"].instance()
		initialize_enemy(enemy, $Player)
		if enemy_attributes.get("animation", null):
			enemy.customdeathanimation = enemy_attributes["animation"]
		else:
			pass
		if enemies_defeated == 4:
			enemy.z_index = 20
		enemy.position = spawnpoints[enemies_defeated].position
		living_enemies = 1
		add_child(enemy)
	
	if living_enemies == 0 and enemies_defeated >= enemies.size():
		$CountDownTimer.start()
	else:
		pass
	

func _on_CountDownTimer_timeout():
	$NextLevelNode.show() # Replace with function body.

	
func next_level():
	$SpawnTimer.stop()
	$CountDownTimer.stop()
	pass
#	get_tree().change_scene("res:///scenes/StartMenu.tscn")
	
func remove_enemy():
	living_enemies = 0
	enemies_defeated += 1


func start_game():
		
	$Player.refresh()
	living_enemies = 0
	$SpawnTimer.start()

func game_over():
	get_tree().call_group("enemies", "queue_free")
#	enemies = []
	$SpawnTimer.stop()


func _on_NextLevel_pressed():
	next_level()
	pass # Replace with function body.


