extends Node

export(PackedScene) var enemy_scene 
export(PackedScene) var rail_enemy

# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var random = RandomNumberGenerator.new()
var enemies = []
var spawnpoints = []

var enemytypes = [enemy_scene, rail_enemy]

var enemygroups = [
	{
		'enemy_type': 'Spawnpoints',
		'points': []
	}, 
	{
		'enemy_type': 'RailSpawnpoints',
		'points': [] 
	}
]

func return_enemy(key):
	match key:
		'RailSpawnpoints':
			return rail_enemy.instance()
		'Spawnpoints':
			return enemy_scene.instance()

# Called when the node enters the scene tree for the first time.
func _ready():
	start_game()


# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	#TODO: Handle this differently. Do not check for player death every frame, only on hit
#	if $Player.dead == true:
#		game_over()
#		$Player.dead = false


func _get_spawnpoints():
	for s in enemygroups: 
		var points = get_node(s['enemy_type']).get_children()
		for p in points:
			s['points'].push_back(p.position)
	pass


func _on_SpawnTimer_delete_bis_timeout():
#	var spawnPoint
#	var enemy
#
#	if spawnpoints:
#		var spawnIndex = randi() % spawnpoints.size()
#		spawnPoint = spawnpoints[spawnIndex]
#		spawnpoints.remove(spawnIndex)
#	else:
#		return
#
#	if spawnPoint.is_in_group('rail'):
#		enemy = rail_enemy.instance()
#	else: 
#		enemy = enemy_scene.instance()
	if enemygroups:
		var enemyIndex = randi() % enemygroups.size()
		var spawnGroup = enemygroups[enemyIndex]
		var spawnIndex = randi() % spawnGroup['points'].size()
		var spawnPoint = spawnGroup['points'][spawnIndex]
		var enemy = return_enemy(spawnGroup['enemy_type'])
		spawnGroup['points'].remove(spawnIndex)
		if spawnGroup['points'].size() < 1:
			enemygroups.remove(enemyIndex)
		$Player.connect("playerfire", enemy, "handle_shotat")
		enemy.connect("gunshot", self, "handle_shotat")
		random.randomize()
		enemy.position = spawnPoint 
		add_child(enemy)
		enemies.push_back(enemy)
	elif number_of_living_enemies() < 1:
		get_tree().change_scene("res:///scenes/StartMenu.tscn")
	else:
		pass
	





func handle_shotat():
	# hit algorithm
	var living = number_of_living_enemies()
	random.randomize()
	var roll = random.randi_range(1, 20)
	print(roll)
	var hit = (roll + living) > 17
	if hit: 
		$Player.handle_hit()

	
func number_of_living_enemies():
	var counter = 0
	for e in enemies:
		if e.dead == false:
			counter = counter + 1
	return counter


func start_game():
	$Player.refresh()
	_get_spawnpoints()
	$"SpawnTimer (delete bis)".start()

func game_over():
	get_tree().call_group("enemies", "queue_free")
	enemies = []
	$PlayerDeath.play()
	$"SpawnTimer (delete bis)".stop()
	var gover = $Player.get_node("GameOver")
	var rg = $Player.get_node("Restart")
	gover.show()
	rg.show()
	pass


func _on_Player_death():
	game_over()
	pass # Replace with function body.


func _on_Player_start_game():
	start_game() # Replace with function body.
