extends CanvasLayer


# Declare member variables here. Examples:
# var a = 2
# var b = "text"
var starting_health = 3
var current_health = starting_health
var clipsize = 6
var current_ammo = clipsize
var health_symbol = "+"
var dead = false
var can_shoot = true
var random = RandomNumberGenerator.new()
signal death
signal start_game
signal playerfire

# Called when the node enters the scene tree for the first time.
func _ready():
	$Restart.hide()
	render_health()
	render_ammo()
	pass # Replace with function body.


func _input(event):
	if (
		event is InputEventMouseButton and 
		event.pressed == true and 
		event.button_index == BUTTON_LEFT
	):
		if can_shoot:
			if current_ammo > 0:
				$gunshot.play()
				emit_signal("playerfire")
				current_ammo-=1
				render_ammo()
			else:
				$gunclick.play()

# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass

func calculate_hit(modifier):
	random.randomize()
	# D20 odds because I'm fucking lazy and suck at math 
	var roll = random.randi_range(1, 20)
	print(roll)
	if (roll + modifier) > 17:
		return true
	else:
		return false

func render_ammo():
	var bullet_counter = "Bullets: "
	$Bullets.text = bullet_counter + str(current_ammo)

func render_health(): 
	var health_bar = ""
	for s in current_health:
		health_bar = health_bar + health_symbol
	$Health.text = health_bar

func handle_shotat(living):
	# hit algorithm
	if calculate_hit(living): 
		handle_hit()

func handle_hit():
	current_health-=1
	render_health()
	if current_health < 1:
		dead = true
		$playerdeath.play()
		emit_signal("death")
	else:
		$playerhit.play()
	
	
# TODO: redundant, perhaps call ready instead?	
func refresh():
	current_health = starting_health
	current_ammo = clipsize
	render_health()
	render_ammo()

func _on_Reload_pressed():
	current_ammo = clipsize
	$reload.play()
	render_ammo()
	pass # Replace with function body.



func _on_Restart_pressed():
	$Restart.hide()
	$GameOver.hide()
	emit_signal("start_game")
	pass # Replace with function body.


func _on_Reload_mouse_entered():
	can_shoot = false
	pass # Replace with function body.


func _on_Reload_mouse_exited():
	can_shoot = true
	pass # Replace with function body.

